------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Sort_Filter_Proxy_Model_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Sort_Filter_Proxy_Model_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Sort_Filter_Proxy_Models is

   function dynamicSortFilter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, dynamicSortFilter_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_dynamicSortFilter_0_wrapper");

   function filterCaseSensitivity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Case_Sensitivity;
   pragma Import (C, filterCaseSensitivity_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_filterCaseSensitivity_0_wrapper");

   function filterKeyColumn_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, filterKeyColumn_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_filterKeyColumn_0_wrapper");

   procedure filterRegExp_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Reg_Exps.Internals.QRegExp);
   pragma Import (C, filterRegExp_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_filterRegExp_0_wrapper");

   function filterRole_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, filterRole_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_filterRole_0_wrapper");

   function isSortLocaleAware_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isSortLocaleAware_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_isSortLocaleAware_0_wrapper");

   procedure setDynamicSortFilter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setDynamicSortFilter_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setDynamicSortFilter_0_wrapper");

   procedure setFilterCaseSensitivity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Cs : Qt4.Case_Sensitivity);
   pragma Import (C, setFilterCaseSensitivity_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setFilterCaseSensitivity_0_wrapper");

   procedure setFilterKeyColumn_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Column : Qt4.Q_Integer);
   pragma Import (C, setFilterKeyColumn_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setFilterKeyColumn_0_wrapper");

   procedure setFilterRegExp_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Reg_Exp : not null access constant Qt4.Reg_Exps.Internals.QRegExp);
   pragma Import (C, setFilterRegExp_1_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setFilterRegExp_1_wrapper");

   procedure setFilterRole_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Role : Qt4.Q_Integer);
   pragma Import (C, setFilterRole_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setFilterRole_0_wrapper");

   procedure setSortCaseSensitivity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Cs : Qt4.Case_Sensitivity);
   pragma Import (C, setSortCaseSensitivity_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setSortCaseSensitivity_0_wrapper");

   procedure setSortLocaleAware_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     On : Qt4.bool);
   pragma Import (C, setSortLocaleAware_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setSortLocaleAware_0_wrapper");

   procedure setSortRole_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Role : Qt4.Q_Integer);
   pragma Import (C, setSortRole_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setSortRole_0_wrapper");

   function sortCaseSensitivity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Case_Sensitivity;
   pragma Import (C, sortCaseSensitivity_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_sortCaseSensitivity_0_wrapper");

   function sortRole_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, sortRole_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_sortRole_0_wrapper");

   procedure invalidate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, invalidate_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_invalidate_0_wrapper");

   procedure setFilterFixedString_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pattern : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setFilterFixedString_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setFilterFixedString_0_wrapper");

   procedure setFilterRegExp_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pattern : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setFilterRegExp_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setFilterRegExp_0_wrapper");

   procedure setFilterWildcard_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pattern : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setFilterWildcard_0_wrapper,
                     "__Qt4Ada_QSortFilterProxyModel_setFilterWildcard_0_wrapper");

   pragma Style_Checks ("N");

   -------------------------
   -- Dynamic_Sort_Filter --
   -------------------------

   function Dynamic_Sort_Filter
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (dynamicSortFilter_0_wrapper
           (Self.QObject_View));
   end Dynamic_Sort_Filter;

   -----------------------------
   -- Filter_Case_Sensitivity --
   -----------------------------

   function Filter_Case_Sensitivity
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Case_Sensitivity
   is
   begin
      return
        filterCaseSensitivity_0_wrapper
         (Self.QObject_View);
   end Filter_Case_Sensitivity;

   -----------------------
   -- Filter_Key_Column --
   -----------------------

   function Filter_Key_Column
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        filterKeyColumn_0_wrapper
         (Self.QObject_View);
   end Filter_Key_Column;

   --------------------
   -- Filter_Reg_Exp --
   --------------------

   function Filter_Reg_Exp
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Reg_Exps.Q_Reg_Exp
   is
      Returns : Qt4.Reg_Exps.Q_Reg_Exp;

   begin
      filterRegExp_0_wrapper
       (Self.QObject_View,
        Qt4.Reg_Exps.Internals.QRegExp_View (Returns));

      return Returns;
   end Filter_Reg_Exp;

   -----------------
   -- Filter_Role --
   -----------------

   function Filter_Role
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        filterRole_0_wrapper
         (Self.QObject_View);
   end Filter_Role;

   --------------------------
   -- Is_Sort_Locale_Aware --
   --------------------------

   function Is_Sort_Locale_Aware
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isSortLocaleAware_0_wrapper
           (Self.QObject_View));
   end Is_Sort_Locale_Aware;

   -----------------------------
   -- Set_Dynamic_Sort_Filter --
   -----------------------------

   procedure Set_Dynamic_Sort_Filter
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Enable : Standard.Boolean)
   is
   begin
      setDynamicSortFilter_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Dynamic_Sort_Filter;

   ---------------------------------
   -- Set_Filter_Case_Sensitivity --
   ---------------------------------

   procedure Set_Filter_Case_Sensitivity
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Cs : Qt4.Case_Sensitivity)
   is
   begin
      setFilterCaseSensitivity_0_wrapper
       (Self.QObject_View,
        Cs);
   end Set_Filter_Case_Sensitivity;

   ---------------------------
   -- Set_Filter_Key_Column --
   ---------------------------

   procedure Set_Filter_Key_Column
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Column : Qt4.Q_Integer)
   is
   begin
      setFilterKeyColumn_0_wrapper
       (Self.QObject_View,
        Column);
   end Set_Filter_Key_Column;

   ------------------------
   -- Set_Filter_Reg_Exp --
   ------------------------

   procedure Set_Filter_Reg_Exp
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Reg_Exp : Qt4.Reg_Exps.Q_Reg_Exp)
   is
   begin
      setFilterRegExp_1_wrapper
       (Self.QObject_View,
        Qt4.Reg_Exps.Internals.QRegExp_View (Reg_Exp));
   end Set_Filter_Reg_Exp;

   ---------------------
   -- Set_Filter_Role --
   ---------------------

   procedure Set_Filter_Role
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Role : Qt4.Q_Integer)
   is
   begin
      setFilterRole_0_wrapper
       (Self.QObject_View,
        Role);
   end Set_Filter_Role;

   -------------------------------
   -- Set_Sort_Case_Sensitivity --
   -------------------------------

   procedure Set_Sort_Case_Sensitivity
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Cs : Qt4.Case_Sensitivity)
   is
   begin
      setSortCaseSensitivity_0_wrapper
       (Self.QObject_View,
        Cs);
   end Set_Sort_Case_Sensitivity;

   ---------------------------
   -- Set_Sort_Locale_Aware --
   ---------------------------

   procedure Set_Sort_Locale_Aware
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     On : Standard.Boolean)
   is
   begin
      setSortLocaleAware_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (On));
   end Set_Sort_Locale_Aware;

   -------------------
   -- Set_Sort_Role --
   -------------------

   procedure Set_Sort_Role
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Role : Qt4.Q_Integer)
   is
   begin
      setSortRole_0_wrapper
       (Self.QObject_View,
        Role);
   end Set_Sort_Role;

   ---------------------------
   -- Sort_Case_Sensitivity --
   ---------------------------

   function Sort_Case_Sensitivity
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Case_Sensitivity
   is
   begin
      return
        sortCaseSensitivity_0_wrapper
         (Self.QObject_View);
   end Sort_Case_Sensitivity;

   ---------------
   -- Sort_Role --
   ---------------

   function Sort_Role
    (Self : not null access constant Q_Sort_Filter_Proxy_Model'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        sortRole_0_wrapper
         (Self.QObject_View);
   end Sort_Role;

   ----------------
   -- Invalidate --
   ----------------

   procedure Invalidate
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class)
   is
   begin
      invalidate_0_wrapper
       (Self.QObject_View);
   end Invalidate;

   -----------------------------
   -- Set_Filter_Fixed_String --
   -----------------------------

   procedure Set_Filter_Fixed_String
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Pattern : Qt4.Strings.Q_String)
   is
   begin
      setFilterFixedString_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Pattern));
   end Set_Filter_Fixed_String;

   ------------------------
   -- Set_Filter_Reg_Exp --
   ------------------------

   procedure Set_Filter_Reg_Exp
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Pattern : Qt4.Strings.Q_String)
   is
   begin
      setFilterRegExp_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Pattern));
   end Set_Filter_Reg_Exp;

   -------------------------
   -- Set_Filter_Wildcard --
   -------------------------

   procedure Set_Filter_Wildcard
    (Self : not null access Q_Sort_Filter_Proxy_Model'Class;
     Pattern : Qt4.Strings.Q_String)
   is
   begin
      setFilterWildcard_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Pattern));
   end Set_Filter_Wildcard;

end Qt4.Sort_Filter_Proxy_Models;
